package com.jobs;

import java.math.BigDecimal;
import java.math.RoundingMode;

public class Demo2 {
    public static void main(String[] args) {

        BigDecimal bd1 = new BigDecimal("10");
        BigDecimal bd2 = new BigDecimal("3");

        //相加
        BigDecimal add = bd1.add(bd2);
        System.out.println("10/3 相加的结果：" + add);

        //相减
        BigDecimal subtract = bd1.subtract(bd2);
        System.out.println("10/3 相减的结果：" + subtract);

        //相乘
        BigDecimal multiply = bd1.multiply(bd2);
        System.out.println("10/3 相乘的结果：" + multiply);

        //相除（如果能够除尽，则一切正常）
        BigDecimal divide = bd2.divide(bd1);
        System.out.println("3/10 相除的结果：" + divide);

        //相除（如果除不尽，则抛异常）
        //原因：BigDecimal属于精确计算，如果除不尽，必须指定舍入规则
        //BigDecimal divide0 = bd1.divide(bd2);
        //System.out.println("10/3 相除的结果：" + divide0);

        System.out.println("---------------------");
        //常用的三个舍入规则为：
        //RoundingMode.UP 进一法
        //RoundingMode.FLOOR 去尾法
        //RoundingMode.HALF_UP 四舍五入

        System.out.println("相除精确2位小数：");
        BigDecimal divide1 = bd1.divide(bd2, 2, RoundingMode.UP);
        System.out.println("10/3 小数第3位进1的结果：" + divide1);
        BigDecimal divide2 = bd1.divide(bd2, 2, RoundingMode.FLOOR);
        System.out.println("10/3 小数第3位舍去的结果：" + divide2);
        BigDecimal divide3 = bd1.divide(bd2, 2, RoundingMode.HALF_UP);
        System.out.println("10/3 小数第3位四舍五入的结果：" + divide3);

        BigDecimal bd3 = new BigDecimal("0.1");
        BigDecimal bd4 = new BigDecimal("4");
        BigDecimal divide4 = bd3.divide(bd4, 2, RoundingMode.HALF_UP);
        System.out.println("0.1/4 实际结果是 0.025，小数第3位四舍五入的结果：" + divide4);
    }
}
